# Macros Library

## Rust Macros Libraries for **applications**

Part of the following developments:

- [CloudMandala](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)
- [Zteron](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)

Includes applications definitions and functions for following areas:

- Data from json or yaml or toml files

### Criteria

In a basic application scenario this group or library collections are included together.
**app_env** is <u>used</u> even inside other libraries.

Updating packages or dependencies shoud be keep in sync among <u>Cargo.toml</u> declarations.

### How to use

1 - Clone or download this lib in a path, better outside of target development

2 - Get current version from <u>Cargo.toml</u>

3 - <u>For each member of</u>  of **Macros Library** one line like the one below should be included in <u>target development Cargo.toml</u> (adjust version & path) and **use** whatever is need.

```toml
app_auth = { version = "0.1.0", path = "../lib/defs/app_auth" }
```

To include all libraries:

```toml
app_auth = { version = "0.1.0", path = "../lib/defs/app_auth" }
app_env = { version = "0.1.0", path = "../lib/defs/app_env" }
app_errors = { version = "0.1.0", path = "../lib/defs/app_errors" }
app_file = { version = "0.1.0", path = "../lib/defs/app_file" }
kloud = { version = "0.1.0", path = "../lib/defs/kloud" }
```

### Structure

Each directory contains a Library dedicated to applications common needs:
Inside of each directory README.md and TODO.md files has more details.

#### kloud_entries_macro_derive

Macro for kloud storage entries from json or yaml or toml files

<pre>
kloud_entries_macro_derive/
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

## Author

- [Jesús Pérez](https://info.jesusperez.pro).

## License

MIT
